<?php

namespace App\Service;

use App\Entity\Snip;
use App\Entity\User;
use CzProject\GitPhp\Git;
use CzProject\GitPhp\GitRepository;

class SnipService
{
    private GitRepository $repo;

    public function __construct(
        Snip                  $snip,
        string                $snipBasePath,
        private readonly User $user,
    )
    {
        $git = new Git();
        $repoPath = sprintf('%s/%s', $snipBasePath, $snip->getId());
        dump($repoPath, $snip);
        if (!is_dir($repoPath)) {
            $this->repo = $git->init($repoPath);
        } else {
            $this->repo = $git->open($repoPath);
        }
    }

    private function snipExists(): bool
    {
        return file_exists($this->getSnipPath());
    }

    private function getSnipPath(): string
    {
        return sprintf('%s/snip.txt', $this->repo->getRepositoryPath());
    }

    public function update(string $snipContents): void
    {
        dump($this->getSnipPath());
        file_put_contents($this->getSnipPath(), $snipContents);
        $this->repo->addFile('snip.txt');
        if ($this->repo->hasChanges()) {
            $this->repo->commit(sprintf('Updated snip at %s by %s', date('Y-m-d H:i:s'), $this->user));
        }
    }

    public function get(): string
    {
        if (!$this->snipExists()) {
            return '';
        }
        return file_get_contents($this->getSnipPath());
    }
}